GEN = {}
GEN.gVersion = '1.03'

-- mission specific functions 
-- load order :
-- 1 MissionGeneratorTools
-- 2 Templates
-- 3 this script

--#################################################################################################################################################
-- #############   Configuration (mission specific)																					############### 
--#################################################################################################################################################
do -- Variables
  GEN.RED = coalition.side.RED	  
  GEN.BLUE = coalition.side.BLUE	
  GEN.Era							= 2 	-- 2 = Modern , 1 = Cold war
  GEN.patrolZonesCounter = 0
  GEN.patrolZones = {}
  GEN.PatrolZone = ZONE_POLYGON:New( "border", GROUP:FindByName( "border" ) )  
end
do -- Templates
--		            groupName,	displayName,	    category,	   side,               era,     disperse,   size,   properties (table, free format)	

--red
	MGT.addTemplate( 'B-M60'   , 'M60'	, 	   'ground',   coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-M1A2'  , 'M1A2', 	     'ground',   coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-M113'  , 'M113'	, 	   'ground',   coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-M2A2'  , 'M12A2', 	   'ground',   coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-M1126'  , 'M12A2', 	   'ground',   coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-Humvee', 'Humvee'	,    'ground',   coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-Avenger', 'Avenger'	,  'sam',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-Vulcan' , 'Vulcan'	,  'aaa',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'B-Gaz-L'  , 'Gazelle'	,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  --MGT.addTemplate( 'B-Gaz-M'  , 'Gazelle'	,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})
  --MGT.addTemplate( 'B-Gaz-A'  , 'Gazelle'	,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-Apache'   , 'Apache'	  ,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-AH1'   , 'Super Cobra'	  ,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-Kiowa'   , 'Kiowa'	  ,  'heli',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-pilot'  , 'Pilot'	  ,  'pilot',      coalition.side.BLUE, 	  0,          30,		  5,	  {})   
  MGT.addTemplate( 'B-Predator'   , 'Predator'	  ,  'predator',      coalition.side.BLUE, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'B-Roland' , 'Roland ADS'	,  'shorad',      coalition.side.BLUE, 	  0,          30,		  10,	  {})


	MGT.addTemplate( 'R-T55'   , 'T-55'	, 	   'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-T72'   , 'T-72'	, 	   'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'R-MTLB'  , 'MTLB'	, 	   'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-BTR-80', 'BTR-80', 	   'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'R-BMP-1', 'BMP-1', 	   'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-BMP-2', 'BMP-2', 	   'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-Cobra', 'Cobra'	,    'ground',   coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-SA9'   , 'SA-9'	,  'sam',      coalition.side.RED, 	  0,          30,		  10,	  {})
  
  MGT.addTemplate( 'R-Shilka' , 'Shilka'	,  'aaa',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-ZSU-57-2' , 'ZSU-57-2'	,  'aaa',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-ZSU-57-2' , 'R-ZU-23-2'	,  'aaa',      coalition.side.RED, 	  0,          30,		  10,	  {}) 
  
  MGT.addTemplate( 'R-Mi8'  , 'Mi-8'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-Mi8-1'  , 'Mi-8'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-Mi24'  , 'Mi-24'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  MGT.addTemplate( 'R-Ka50'  , 'Ka-50'	,  'heli',      coalition.side.RED, 	  0,          30,		  10,	  {})
  
  MGT.addTemplate( 'R-MRL',   'MRLS Battery', 	  'support',   coalition.side.RED, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'R-ART',   'Artillery Battery', 	  'support',   coalition.side.RED, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'R-Sup',   'Supply Plt.', 	  'support',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-HQ',   'HQ Plt.', 	  'hq',   coalition.side.RED, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'R-SA-8',   'SA-8.', 	  'shorad',   coalition.side.RED, 	  0,          30,		  10,	  {})  
  MGT.addTemplate( 'R-Convoy-1',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-Convoy-2',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-Convoy-3',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-Convoy-4',   'Supply Plt.', 	  'convoy',   coalition.side.RED, 	  0,          30,		  10,	  {})    
  MGT.addTemplate( 'R-INF-2', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-3', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-4', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-5', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})
  MGT.addTemplate( 'R-INF-6', 'Infantry'	,    'inf',   coalition.side.RED, 	  0,          10,		  0,	  {})

end-- Templates

do -- deployment settings										

  GEN.DEF_RED_Ground = 		 {     	
                {name = 'redGround',  border = 'border', class = 'ground'	, zoneQty = 11, deployZoneQty = 11, zonePrefix = 'red', 	minPerZone = 0 , maxPerZone = 2 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'CAS',
                components = {}
              }} -- DEF_RED_Ground

  GEN.DEF_RED_sam = 		 {     	
                {name = 'redGround',  border = 'border', class = 'sam'	, zoneQty = 11, deployZoneQty = 1, zonePrefix = 'red', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'SEAD',
								components = {}														
                }} -- DEF_RED_sam              
   GEN.DEF_RED_aaa = 		 {     	
                {name = 'redGround',  border = 'border', class = 'aaa'	, zoneQty = 11, deployZoneQty = 3, zonePrefix = 'red', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'SEAD',
								components = {}														
              }} -- DEF_RED_aaa         
            
  GEN.DEF_RED_Sup= 		 {     	
                {name = 'redGround',  border = 'border', class = 'support'	, zoneQty = 6, deployZoneQty = 6, zonePrefix = 'red-sup', 	minPerZone = 1 , maxPerZone = 2 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'BAI',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 1, minDist =  50, maxDist =  100, probPerSite = 25, side = coalition.side.RED},                  
                  }
              }} -- DEF_RED_Ground
            
  GEN.DEF_RED_HQ= 		 {     	
                {name = 'redGround',  border = 'border', class = 'hq'	, zoneQty = 2, deployZoneQty = 1, zonePrefix = 'search', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'BAI-C2/HQ',
                components = {
                    {class = 'aaa'		,	minPerSite = 1 , maxPerSite = 1, minDist =  50, maxDist =  100, probPerSite = 25, side = coalition.side.RED},
                    {class = 'sam'		,	minPerSite = 1 , maxPerSite = 1, minDist =  50, maxDist =  100, probPerSite = 10, side = coalition.side.RED},                    
                  }
              }} -- DEF_RED_Ground       
  GEN.DEF_RED_Shorad= 		 {     	
                {name = 'redGround',  border = 'border', class = 'shorad'	, zoneQty = 2, deployZoneQty = 2, zonePrefix = 'search', 	minPerZone = 0 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'SEAD',
                components = {
               
                  }
              }} -- DEF_RED_Ground                
    
    GEN.DEF_RED_Convoy= 		 {     	
                {name = 'convoy',  border = 'border', class = 'convoy'	, zoneQty = 4, deployZoneQty = 4, zonePrefix = 'red-start', 	minPerZone = 1 , maxPerZone = 3 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = true, missionRadius = 500, missionName = 'BAI - Convoy Interdiction',
                components = {
                   
                  }
              }} -- DEF_RED_Ground
    
     GEN.DEF_RED_Inf= 		 {     	
                {name = 'redGround',  border = 'border', class = 'inf'	, zoneQty = 120, deployZoneQty = 34, zonePrefix = 'red-ifn', 	minPerZone = 0 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.RED, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
                components = {
               
                  }
              }} -- DEF_RED_Ground    
                           
              
  GEN.DEF_BLUE_Ground = 		 {     	
                {name = 'blueGround',  border = 'border', class = 'ground'	, zoneQty = 12, deployZoneQty = 12, zonePrefix = 'blue', 	minPerZone = 1 , maxPerZone = 2 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
								components = {}					
                }} -- DEF_BLUE_Ground
              
  GEN.DEF_BLUE_sam = 		 {     	
                {name = 'blueSam',  border = 'border', class = 'sam'	, zoneQty = 12, deployZoneQty = 3, zonePrefix = 'blue', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
								components = {}					
                }} -- DEF_BLUE_sam              
   GEN.DEF_BLUE_aaa = 		 {     	
                {name = 'blueAAA',  border = 'border', class = 'aaa'	, zoneQty = 12, deployZoneQty = 4, zonePrefix = 'blue', 	minPerZone = 1 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
								components = {}
                }} -- DEF_BLUE_aaa              
     GEN.DEF_BLUE_Shorad= 		 {     	
                {name = 'blueShorad',  border = 'border', class = 'shorad'	, zoneQty = 1, deployZoneQty = 1, zonePrefix = 'blue-shorad', 	minPerZone = 0 , maxPerZone = 1 ,
                probPerZone = 100 , side = coalition.side.BLUE, terrain = {'LAND','ROAD'}, mission = false, missionRadius = 500, missionName = '',
                components = {
               
                  }
              }} -- DEF_RED_Ground                               
   
           
end -- deployment settings



--#################################################################################################################################################
-- #############   Initialization of globals (mission specific)																		                                  ############### 
--#################################################################################################################################################
do
  GEN.blueGROUPS = {}
  GEN.redGROUPS = {}
  GEN.clientConfig = {}
  GEN.movingGroups = {}
  GEN.movingGroups[coalition.side.RED] = {}
  GEN.movingGroups[coalition.side.BLUE] = {}

  GEN.playerUnits = {}
  GEN.playerGroups = {}
  GEN.PlayerKillTable ={}
  GEN.playerGroupsByID = {}
  GEN.ROEchangeRadiusOnMark = 1000
  GEN.ROEchangeRadiusOnShot = 1000
  GEN.maxWPmarkDist = 50
  GEN.minWPmarkDist = 20
  GEN.rootMenus = {}

  GEN.rootMenus = {}
  GEN.ROEexclusions = {}
  
  GEN.RedBase = ''
  GEN.acType = ''
  GEN.acType1 = ''  
  GEN.RedEWR = ''
  
  GEN.taskXgroupID = {}
  GEN.taskXgroupID_Dest = {}
  GEN.taskCatalog = {}


end
--#################################################################################################################################################
-- #############   Event Handlers											 	                                                   													############### 
--#################################################################################################################################################
GEN.EventHandler = {}
function GEN.EventHandler:onEvent(_eventDCS)

	if _eventDCS == nil or _eventDCS.initiator == nil then
		return true
	end

	local status, err = pcall(function(_event)

			if _event.id == world.event.S_EVENT_BIRTH  and _event.initiator:getPlayerName()   then  


				GEN.initUnit(_event.initiator:getName())
			
      elseif ( _event.id == world.event.S_EVENT_SHOOTING_START ) or (_event.id == world.event.S_EVENT_SHOT) then 
				
				timer.scheduleFunction(GEN.ShootingEvent, {_event},  timer.getTime() + mist.random(20,50) ) 	
        
			elseif (_event.id == world.event.S_EVENT_EJECTION or _event.id == world.event.S_EVENT_PILOT_DEAD ) and _event.initiator:getPlayerName() then 	
				
				GEN.showScore(_event.initiator:getName())		
			elseif (_event.id == world.event.S_EVENT_KILL)  then 
				GEN.KillEvent(_event)
				
			end --if (_event.id ==
								
		  -- ### End event processing

			return true
	end, _eventDCS) --  local status, err = pcall(function(_event)

	if (not status) then 
		local msg = string.format(">>>>>>>>>>> (v%s): Error while handling event %s",GEN.gVersion, err)
		env.error(msg,false)
	end
end
--===================================================================================================================================================
function GEN.DeadEvent(_event)
	env.info('GEN.DeadEvent() running',false)
	local Name = _event.initiator:getName()
	local Type = _event.initiator:getTypeName()
	local _status,coaliton = pcall(function()
							return {_event.initiator:getCoalition()}
							end)	
	if not _status then
		coalition = 0	
	end 
	

	
	if coalition ~= 0 then
		if Type then
			trigger.action.outText(string.format('%s (%s) destroyed',Name,Type), 10)
		else
			trigger.action.outText(string.format('%s destroyed',Name), 10)
		end
	end
	
end -- function
--===================================================================================================================================================
function GEN.KillEvent(_event)
	env.info('GEN.KillEvent() running',false)
	
	
	if _event.initiator ~= nil and _event.target ~= nil  then
		local p =  _event.initiator:getPlayerName() 
		
		if not p then
			if _event.initiator:getCoalition() == 1 then
				p = 'Red AI'
			else
				p = 'Blue AI'
			end
		end
		
		
		
		if not GEN.PlayerKillTable[p] then
			GEN.PlayerKillTable[p] = {}
		end
		
		local t = _event.target:getTypeName()
		if t then
      local weapon = (_event.target:getCategory() == 2)
      if not weapon then
        if not GEN.PlayerKillTable[p][t] then
          GEN.PlayerKillTable[p][t] = {}
        end
        local c = 'Neutral'    
        if _event.target:getCoalition() <= 1   then
          c = 'Red'
        elseif _event.target:getCoalition() == 2 then
          c = 'Blue'
        end
        
        if not GEN.PlayerKillTable[p][t][c] then
          GEN.PlayerKillTable[p][t][c] = 1
        else
          GEN.PlayerKillTable[p][t][c] = GEN.PlayerKillTable[p][t][c]  + 1
        end
        env.info('GEN.KillEvent() p<'..p..'> t<'..t..'> c<'..c..'>',false)
      end
    end
	end
	
end -- function
--===================================================================================================================================================
function GEN.ShootingEvent(params,time)

	env.info('GEN.ShootingEvent() running',false)
	local _event = params[1]
	local _status,shooterName  pcall(function() return _event.initiator:getName() end)
	
	if _status then
		local UnitZoneTable = GEN.getUnitZoneTable('ALL')	
		
		local t = mist.getUnitsInMovingZones(UnitZoneTable, {shooterName}, GEN.ROEchangeRadiusOnShot, 'cylinder')
		
		
		for i = 1,d35.rowCount(t) do
			d35.setGroupOption(t[i]:getGroup():getName(),0,2) -- open fire
		end --for i = 1,d35.rowCount(t) do
	end	
	return nil
end --function
--===================================================================================================================================================
function GEN.initUnit(unitName)
	local unit = Unit.getByName(unitName)
	local groupID = unit:getGroup():getID()
	local groupName = unit:getGroup():getName()
	local unitType =  unit:getTypeName()
	local side = unit:getCoalition()
	local clientConfig = {
								groupID = groupID
							,	unitType = unitType
							,	side = side
							,	AltitudeUOM = 1
						}
		
	if not GEN.clientConfig[unitName] then -- new player
		dummy = 0
		
	else -- returning player
		dummy = 0
	end

	if not d35.inTable(unitName,GEN.playerUnits) then
		table.insert(GEN.playerUnits,unitName)
		if not d35.inTable(groupID,GEN.playerGroups) then
			table.insert(GEN.playerGroups,groupID)
			GEN.rootMenus[groupID] ={}
			GEN.playerGroupsByID[groupID] = groupName
			GEN.rootMenus[groupID]['Intelligence'] =  missionCommands.addSubMenuForGroup(groupID,'Intelligence',nil)
			missionCommands.addCommandForGroup(groupID,"Intelligence Summary", GEN.rootMenus[groupID]['Intelligence'] , GEN.showScore, groupName) 
			missionCommands.addCommandForGroup(groupID,"Kills Summary", GEN.rootMenus[groupID]['Intelligence'] ,GEN.showKills, groupName )
      missionCommands.addCommandForGroup(groupID,"Request Tasking", GEN.rootMenus[groupID]['Intelligence'] ,GEN.requestTasking, {groupID,groupName} )
      missionCommands.addCommandForGroup(groupID,"Deploy Predator", GEN.rootMenus[groupID]['Intelligence'] ,GEN.deployPredator, {} )
      GEN.taskXgroupID[groupID] = nil
		end
	end
  GEN.clientConfig[unitName] = clientConfig
	return true
end
--#################################################################################################################################################
-- #############   mission generation code						                                          			 	  													############### 
--#################################################################################################################################################
function GEN.addGroups(_groupData, _side)
	local h,n  = d35.getGroupHealth(_groupData.name)
	local id =  d35.getNextID()
	local row = {
				name 		        = _groupData.name
			,	displayName     = _groupData.template.displayName
			,	position	      = _groupData.pos
			,	health0		      = h
			, isTarget	      = false
			, unitCount0        = n
			, templateGroupName	= _groupData.template.groupName
			, templateCategory	= _groupData.template.category
			,	afacPriority		  = _groupData.template.afacPri
			,	brief				      = _groupData.template.brief
			,	id					      =  id
		}
		
	env.info('GEN.addGroups(): Group: '.._groupData.name..' side: '.._side..' h0/n :'..h..'/'..n,false)
		
	if _side == 1 then
		GEN.redGROUPS[row.name] = row
	elseif _side == 2 then
		GEN.blueGROUPS[row.name] = row
	end
end-- function
--===================================================================================================================================================
function GEN.deployUnits(definition)
  env.error('GEN.deployUnits() in: ',false)
 
	for _,siteType in pairs(definition) do
    env.error('GEN.deployUnits() start: '..siteType.name,false)
    local border = siteType.border
		local zoneList = {}
		local TMPzoneList = mist.randomizeNumTable( {size = siteType.zoneQty,  lowerLimit = 1, upperLimit = siteType.zoneQty})
		for i = 1,siteType.deployZoneQty do
			table.insert(zoneList,TMPzoneList[i])
		end
		for _,z in pairs(zoneList) do
			if mist.random(1,100) <= siteType.probPerZone then
				local qty = mist.random(siteType.minPerZone,siteType.maxPerZone)
				env.error('GEN.deployUnits(): '..siteType.class..' @ '..string.format('%s-%s',siteType.zonePrefix,z)..' #:'..qty,false)
				if qty > 0 then
					local zone = trigger.misc.getZone(string.format('%s-%s',siteType.zonePrefix,z))
					for i = 1,qty do
						local templates, n = MGT.getTemplateList ({siteType.class}, siteType.side, GEN.Era)
						local template = templates[mist.random(1,n)]
            
						local deployedGroups = MGT.populateLand({template}, 1, zone.point, border	, 0, zone.radius, 0,0,0,true,siteType.terrain,4000)
            local my_csar = CSAR:New(coalition.side.BLUE,"Downed Pilot","Luftrettung")
						local nGrp = d35.rowCount(deployedGroups) 
						env.error('GEN.deployUnits(): '..template.groupName,false)
						for j = 1,nGrp do
							local site = deployedGroups[j]
							GEN.addGroups(site,siteType.side)-- group to red list	
							-- do anything aditional at site level
              -- add supression
              if not d35.inTable(siteType.name,{'Naval'}) then
                local G = GROUP:FindByName(site.name)
                local S = SUPPRESSION:New(G)
       
                S:Fallback(false)
                S:Takecover(false)
              end
                      
			
              local C = nil
              if  d35.inTable(siteType.name,{'convoy'}) then
                  local speed = mist.random(10, 20)
                  local G = GROUP:FindByName(site.name)
                  local d = mist.random(1, 6)
                  local dest = "red-sup-"..d
                  C = COORDINATE:NewFromVec2(mist.getRandomPointInZone(dest,0))
                  G:RouteGroundOnRoad(C, speed, 1)
               end
              
              if siteType.mission then
                local name = siteType.missionName
                if name == '' then
                  name = template.displayName
                end 
                local task = {target = site.name, radius = siteType.missionRadius, displayName = name, destination = C}
                table.insert(GEN.taskCatalog,task)
              end
              
              
              -- Deploy site components 
							env.error('GEN.deployUnits(): components '..d35.rowCount(siteType.components),false)
							if d35.rowCount(siteType.components) > 0 then
								for _,def in pairs(siteType.components) do
									if mist.random(1,100) <= def.probPerSite then
										local dqty = mist.random(def.minPerSite,def.maxPerSite)
										env.error('MGT.deployUnits(): component '..def.class..' @ '..string.format('%s-%s',siteType.zonePrefix,z)..' #:'..dqty,false)
										if dqty > 0 then
											local dtemplates, dn = MGT.getTemplateList ({def.class}, def.side, GEN.Era)
											local dtemplate = dtemplates[mist.random(1,dn)]
											local ddeployedGroups = MGT.populateLand({dtemplate}, dqty, site.pos, border , def.minDist, def.maxDist, 0,0,0,false,{'LAND'},1000)
											local dnGrp = d35.rowCount(ddeployedGroups) 
											env.error('MGT.deployUnits(): component '..dtemplate.groupName,false)
											for dj = 1,dnGrp do
												local grp = ddeployedGroups[dj]
												GEN.addGroups(grp,def.side)-- group to red list		
												-- do anything aditional at component level

                        -- add supression
                        local G = GROUP:FindByName(grp.name)
                        local S = SUPPRESSION:New(G)
                        S:Fallback(false)
                        S:Takecover(false)
												
											end--for dj = 1,dnGrp do
										end--if dqty > 0 then
									end --if mist.random(1,100) <= def.probPerSite then
								end--for _,def in pairs(siteType.component) do
							end -- if MGT.rowCount(siteType.component) > 0 then					
						end	--for j = 1,nGrp do		
					end -- for i = 1,qty do
				end -- if qty > 0 then
			end --if mist.random(1,100) <= siteType.probPerZone then
		end -- for _,z = 1 in pairs(zoneList) do
    env.error('GEN.deployUnits() end: '..siteType.name,false)
	end --for _,siteType in pairs(MGT.UnitsDef) do

	env.error('GEN.deployUnits() out: ',false)

	--trigger.action.outText( 'Units Deployed ', 1 )
end -- function
--===================================================================================================================================================
function GEN.deployRedAir()


  GEN.red_DetectionSetGroup = SET_GROUP:New()
	GEN.red_DetectionSetGroup:FilterPrefixes( {  "R-"} ) -- Depends on IADS EWR network
	GEN.red_DetectionSetGroup:FilterStart()	
  
 
  local Detection = DETECTION_AREAS:New(GEN.red_DetectionSetGroup, 500000 )
  local BAIZone1 = ZONE_POLYGON:New( "border", GROUP:FindByName( 'border') )
	GEN.RED_A2GDispatcher = AI_A2G_DISPATCHER:New( Detection )
	GEN.RED_A2GDispatcher:SetDefaultOverhead( 1 )
  GEN.RED_A2GDispatcher:SetDefenseRadius( 30000 )
	GEN.RED_A2GDispatcher:SetDefenseReactivityHigh()
  GEN.RED_A2GDispatcher:SetBorderZone( BAIZone1 )


  local templates, n = MGT.getTemplateList ({'heli'}, coalition.side.RED, GEN.Era)
  local prefix ='R-FARP-'
  local types = {}
  for i = 1,n do
    table.insert(types,templates[i].groupName)
  end
  for i = 1,1 do
    local SQDNname = prefix..i
    GEN.RED_A2GDispatcher:SetSquadron(SQDNname, SQDNname, types , 20)
    GEN.RED_A2GDispatcher:SetSquadronTakeoffFromParkingHot(SQDNname)
    GEN.RED_A2GDispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
    GEN.RED_A2GDispatcher:SetSquadronGrouping(SQDNname, 1 )
    GEN.RED_A2GDispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
    GEN.RED_A2GDispatcher:SetSquadronBaiPatrol( SQDNname,BAIZone1,100,500)
    GEN.RED_A2GDispatcher:SetSquadronBaiPatrolInterval(SQDNname, 2, 15, 30)
  end
  
  
end-- function
--===================================================================================================================================================
function GEN.deployPredator()
  local templates, n = MGT.getTemplateList ({'predator'}, coalition.side.BLUE, GEN.Era)
  local template = templates[mist.random(1,n)]
  local newGRPname = string.format('%s-%s',template.groupName,d35.getNextID())
  local flightSpawn = SPAWN:NewWithAlias( template.groupName,newGRPname)
  local flight = flightSpawn:Spawn()
  
  GEN.patrolZonesCounter = GEN.patrolZonesCounter + 1
  if GEN.patrolZonesCounter > 20 then
     GEN.patrolZonesCounter = 1
  end
  
  GEN.patrolZones[GEN.patrolZonesCounter] = AI_PATROL_ZONE:New( GEN.PatrolZone, mist.random(mist.utils.feetToMeters(15000),mist.utils.feetToMeters(25000))
                                                                        , mist.random(mist.utils.feetToMeters(15000),mist.utils.feetToMeters(25000))
                                                                        , mist.random(mist.utils.knotsToMps(100)*3.6,mist.utils.knotsToMps(150)*3.6)
                                                                        , mist.random(mist.utils.knotsToMps(100)*3.6,mist.utils.knotsToMps(150)*3.6) )
  GEN.patrolZones[GEN.patrolZonesCounter]:SetControllable(flight)
  GEN.patrolZones[GEN.patrolZonesCounter]:Start(1)
  
  
end -- function
--===================================================================================================================================================
function GEN.deployBlueAir()

  GEN.blue_DetectionSetGroup = SET_GROUP:New()
	GEN.blue_DetectionSetGroup:FilterPrefixes( {  "B-"} ) -- Depends on IADS EWR network
	GEN.blue_DetectionSetGroup:FilterStart()	
  
 
  local Detection = DETECTION_AREAS:New(GEN.blue_DetectionSetGroup, 500000 )
  local BAIZone1 = ZONE_POLYGON:New( "border", GROUP:FindByName( 'border') )
	GEN.BLUE_A2GDispatcher = AI_A2G_DISPATCHER:New( Detection )
	GEN.BLUE_A2GDispatcher:SetDefaultOverhead( 1 )
  GEN.BLUE_A2GDispatcher:SetDefenseRadius( 30000 )
	GEN.BLUE_A2GDispatcher:SetDefenseReactivityHigh()
  GEN.BLUE_A2GDispatcher:SetBorderZone( BAIZone1 )


  local templates, n = MGT.getTemplateList ({'heli'}, coalition.side.BLUE, GEN.Era)
  local prefix ='B-FARP-'
  local types = {}
  for i = 1,n do
    table.insert(types,templates[i].groupName)
  end
  for i = 1,1 do
    local SQDNname = prefix..i
    GEN.BLUE_A2GDispatcher:SetSquadron(SQDNname, 'FARP London - 01', types , 20)
    GEN.BLUE_A2GDispatcher:SetSquadronTakeoffFromParkingHot(SQDNname)
    GEN.BLUE_A2GDispatcher:SetSquadronLandingAtEngineShutdown(SQDNname)
    GEN.BLUE_A2GDispatcher:SetSquadronGrouping(SQDNname, 1 )
    GEN.BLUE_A2GDispatcher:SetSquadronFuelThreshold(SQDNname, 0.30 ) 
    GEN.BLUE_A2GDispatcher:SetSquadronBaiPatrol( SQDNname,BAIZone1,100,500)
    GEN.BLUE_A2GDispatcher:SetSquadronBaiPatrolInterval(SQDNname, 2, 15, 30)
  end
  
 -- GEN.BLUE_A2GDispatcher:SetTacticalDisplay( true )

end-- function
--===================================================================================================================================================
function GEN.deploySAR(params, time)
 local zone = 'search-'..mist.random(1,2)
 BlueCsar:SpawnCSARAtZone( zone, coalition.side.BLUE,"Pilot One", true )
 env.info('>>> GEN.deploySAR() ',false)
 return timer.getTime() + 600 + mist.random(0,300)
end -- function
--===================================================================================================================================================
function GEN.deploy()
  env.info('GEN.deploy() starts',false)

  BlueCsar = CSAR:New(coalition.side.BLUE,"B-pilot","Luftrettung") 
  BlueCsar.radioSound = "beacon.ogg" 
  BlueCsar.immortalcrew = true 
  BlueCsar.invisiblecrew = false
  BlueCsar.csarPrefix = { "Gazelle", "Huey"}
  BlueCsar.coordtype = 3
  BlueCsar.csarOncrash = true 
  BlueCsar.enableForAI = true
  BlueCsar.extractDistance = 100
  BlueCsar.loadDistance = 10 
  BlueCsar:__Start(5)

  GEN.deployRedAir()
  GEN.deployBlueAir()


  GEN.deployUnits(GEN.DEF_RED_Ground)
  GEN.deployUnits(GEN.DEF_RED_sam)
  GEN.deployUnits(GEN.DEF_RED_aaa)  
  GEN.deployUnits(GEN.DEF_RED_Sup)
  GEN.deployUnits(GEN.DEF_RED_Shorad)
  GEN.deployUnits(GEN.DEF_RED_HQ)
  GEN.deployUnits(GEN.DEF_RED_Convoy)
  GEN.deployUnits(GEN.DEF_BLUE_Ground)
  GEN.deployUnits(GEN.DEF_RED_Inf)
  GEN.deployUnits(GEN.DEF_BLUE_sam)
  GEN.deployUnits(GEN.DEF_BLUE_aaa)    
  GEN.deployUnits(GEN.DEF_BLUE_Shorad)
  
  timer.scheduleFunction( GEN.deploySAR, {},  timer.getTime() + 30 )

  env.info('GEN.deploy() ends',false)
  trigger.action.outText( 'Deployment completed', 1 )
end -- function
--===================================================================================================================================================
function GEN.getUnitZoneTable(_side)
	-- get one alive unit per red group
	local side = _side
	if not side then
		side = 'RED'
	end
	local t = {}
	if side == 'RED' or side == 'ALL' then 
		for _,v in pairs(GEN.redGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(GEN.redGROUPS) do
	end--if side =- 'RED' or side =- 'ALL' then 
	if side == 'BLUE' or side == 'ALL' then 
		for _,v in pairs(GEN.blueGROUPS) do
			local g = Group.getByName(v.name)
			if g then
				for _,unit in pairs(g:getUnits()) do
					if unit:getLife() >= 1 then
						table.insert(t,unit:getName())
						break
					end
				end --for _,unit in pairs(g) do
			end
		end --for _,v in pairs(GEN.redGROUPS) do
	end--if side =- 'BLUE' or side =- 'ALL' then 
	return t
end -- function
--===================================================================================================================================================
function GEN.setRedGroupROE(_groupName, prob)
  if not d35.inTable(_groupName, GEN.ROEexclusions ) then
    table.insert(GEN.ROEexclusions,_groupName)
    if mist.random(1,100) <= prob then
      d35.setGroupOption(_groupName, 0,2) -- open fire
      env.info(string.format('GEN.setRedGroupROE() %s set to open fire ',_groupName),false)
    else
      d35.setGroupOption(_groupName, 0,3) -- return fire
      env.info(string.format('GEN.setRedGroupROE() %s set to return fire ',_groupName),false)
    end
  end
end --function
--===================================================================================================================================================
function GEN.showKills(_groupName)
	local rpt = ''
	env.info('GEN.showKills start',false)
	if d35.rowCount(GEN.PlayerKillTable) > 0 then
		for player,killsCoalition in pairs(GEN.PlayerKillTable) do
			rpt = string.format('%s%s :\n',rpt,player)
			for t,kc in pairs(killsCoalition) do
				for c,k in pairs(kc) do
					rpt = string.format('%s   -> %s   <%s>(x%s)\n',rpt,t,c,k)
				end
			end
		end		
	else
		rpt = 'nothing to report'
	end
	
	d35.messageToGroup(_groupName,rpt,30)
	env.info('GEN.showKills end',false)

end -- function
--===================================================================================================================================================
function GEN.showScore(_groupName)
	local TU = 0
	local TG = 0
  local msg = ''
	
	-- agregate RED data
  local rTOO = 0
	local rH0 = 0
	local rH = 0
	local rN0 = 0
	local rN = 0
	for _,grpdata in pairs(GEN.redGROUPS) do
		local h,n =  d35.getGroupHealth(grpdata.name)
		rH0 = rH0 + grpdata.health0
		rH = rH + h
		rN0 = rN0 + grpdata.unitCount0 
		rN = rN + n
		if h <=0 then
      rTOO = rTOO + 1
		end
		TG = TG +1
	end
	TU = TU + rN0

  -- agregate BLUE data
  local bTOO = 0
	local bH0 = 0
	local bH = 0
	local bN0 = 0
	local bN = 0    
	for _,grpdata in pairs(GEN.blueGROUPS) do
		local h,n =  d35.getGroupHealth(grpdata.name)
		bH0 = bH0 + grpdata.health0
		bH = bH + h
		bN0 = bN0 + grpdata.unitCount0 
		bN = bN + n
		if h <=0 then
      bTOO = bTOO + 1
		end
		TG = TG +1
	end
	TU = TU + rN0

  
	
	
	msg = 'Enemy Forces \n'
	msg = string.format('%s   Strength: %s%%\n',msg,mist.utils.round(rH*100/rH0, 2))
	--msg = string.format('%s   Groups destroyed: %s\n',msg,rTOO)
	msg = string.format('%s   Units destroyed: %s\n',msg,(rN0-rN))

  
	
	msg = msg..'\nBlue Forces \n'
	msg = string.format('%s   Strength: %s%%\n',msg,mist.utils.round(bH*100/bH0, 2))
	--msg = string.format('%s   Groups destroyed: %s\n',msg,bTOO)
	msg = string.format('%s   Units destroyed: %s\n',msg,(bN0-bN))
	

	
	msg = string.format('%s\n< %s / %s >\n',msg,TG,TU)
	
	
	d35.messageToGroup(_groupName,msg,20)
end-- function
--===================================================================================================================================================
function GEN.requestTasking(params)
  local groupID = params[1]
  local groupName = params[2]
  
  if GEN.taskXgroupID[groupID] then
    trigger.action.removeMark(GEN.taskXgroupID[groupID])
  end
  if GEN.taskXgroupID_Dest[groupID] then
    trigger.action.removeMark(GEN.taskXgroupID_Dest[groupID])
  end
   -- get new task
  if d35.rowCount(GEN.taskCatalog) > 0 then
    local cat = {}
    for _,row in pairs(GEN.taskCatalog) do
      if d35.isGroupAlive(row.target) then
        table.insert(cat,row)
      end
    end--for _,row in pairs(GEN.taskCatalog) do
    local nt = d35.rowCount(cat)
    if nt > 0 then
      local t = mist.random(1,nt)
      local task = cat[t]
      local taskType = 'Search & Destroy'
      if task.radius == 0 then
        taskType = 'Destroy'
      end
      local pos = d35.getGroupPOS(task.target)
      --local C = COORDINATE:NewFromVec3(pos)
      local briefing = task.displayName
      local markID = d35.getNextID()
      d35.messageToGroup(groupName,briefing)
      local markPos =  mist.utils.makeVec3GL(mist.getRandPointInCircle(pos,task.radius,0,0,360))
      trigger.action.markToGroup(markID , briefing , markPos , groupID , true)
      GEN.taskXgroupID[groupID] = markID
      if task.destination then
        local markID = d35.getNextID()
        local markPos =  mist.utils.makeVec3GL(mist.getRandPointInCircle(task.destination:GetVec3() ,task.radius,0,0,360))
        trigger.action.markToGroup(markID , briefing..' destination' , markPos , groupID , true)
        GEN.taskXgroupID_Dest[groupID] = markID
      end
      
      
    else
      d35.messageToGroup(groupName,'No more task available.')
    end --if nt > 0 then
  end-- if d35.rowCount(GEN.taskCatalog) > 0 then

end -- function
--#################################################################################################################################################
-- #############   Main body   														                                                  												############### 
--#################################################################################################################################################
--
do

	-- load event handler
	world.addEventHandler(GEN.EventHandler)

	-- Show AFAC Status
	trigger.action.outText( 'Heli Sandbox - v'..GEN.gVersion, 1 )
end
